#ifndef __SAGEM_MSO_H__
#define __SAGEM_MSO_H__

#include "sagem_mso_ilv.h"

/*
 * MSO/CBM return type and error codes
 * -----------------------------------
 */
typedef BYTE MSO_STATUS;

#if 0
#define ILV_OK                    0 /* Everything is OK */


#define ILVERR_ERROR           0xFF
#endif

MSO_STATUS MSO_Direct(BYTE * send,
                      WORD send_len,
                      BYTE * resp,
                      WORD * resp_len);

MSO_STATUS MSO_GetDescriptor(BYTE * desc,
                             WORD desc_len);
MSO_STATUS MSO_SetSIOBaudrate(DWORD baudrate);

MSO_STATUS MSO_Open(void);
void    MSO_Close(void);
MSO_STATUS MSO_PP_Send(BYTE msoID,
                       BYTE msoRC,
                       BYTE * msoData,
                       WORD msoDataLength);
MSO_STATUS MSO_PP_Recv(BYTE * msoID,
                       BYTE * msoRC,
                       BYTE * msoData,
                       WORD * msoDataLength,
                       DWORD timeout);

MSO_STATUS MSO_Exchange(BYTE * send,
                        WORD send_len,
                        BYTE * resp,
                        WORD * resp_len,
                        DWORD timeout);

BOOL    MSO_ILV_Loop(BYTE * buffer,
                     WORD * offset,
                     BYTE * tag,
                     WORD * length,
                     BYTE ** value);
void    MSO_ILV_Init(BYTE * buffer,
                     WORD * size,
                     BYTE tag);
void    MSO_ILV_Final(BYTE * buffer,
                      WORD * size);
void    MSO_ILV_AddDWord(BYTE * buffer,
                         WORD * size,
                         DWORD value);
void    MSO_ILV_AddWord(BYTE * buffer,
                        WORD * size,
                        WORD value);
void    MSO_ILV_AddByte(BYTE * buffer,
                        WORD * size,
                        BYTE value);
void    MSO_ILV_AddData(BYTE * buffer,
                        WORD * size,
                        BYTE * data,
                        WORD length);

BOOL    MSO_IsAsync(BYTE * buffer);

//typedef void (*MSO_AsyncCallback) (BYTE *, WORD);

#endif
