#ifndef _SPROX_DESFIRE_I_H_
#define _SPROX_DESFIRE_I_H_

#ifdef WIN32
  #define SPROX_DESFIRE_LIB __declspec( dllexport )
#endif

#define SPROX_DESFIRE_FUNC(a)     SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROX_ ## a
#define SPROX_DESFIRE_FUNC2(a, b) SPROX_DESFIRE_LIB a SPROX_DESFIRE_API SPROX_ ## b

#ifndef SPROX_API_REENTRANT
  #define SPROX_DESFIRE_FUNC_EX(a)     SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROX_ ## a
  #define SPROX_DESFIRE_FUNC_EX2(a, b) SPROX_DESFIRE_LIB a SPROX_DESFIRE_API SPROX_ ## b
  #define SPROX_DESFIRE_GET_CTX()      SPROX_DESFIRE_CTX_ST *ctx = &desfire_ctx;
  #define SPROX_DESFIRE_GET_CTX_V()    SPROX_DESFIRE_CTX_ST *ctx = &desfire_ctx;
  #define SPROX_API_CALL(a)            SPROX_ ## a
  #define SPROX_PARAM
  #define SPROX_PARAM_V      void
  #define SPROX_PARAM_P
  #define SPROX_PARAM_PV
  
  #include "hardware/springprox/springprox.h"
  #include "sprox_desfire.h"
  
#else
  #define SPROX_DESFIRE_FUNC_EX(a)     SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROXx_ ## a
  #define SPROX_DESFIRE_FUNC_EX2(a, b) SPROX_DESFIRE_LIB a SPROX_DESFIRE_API SPROXx_ ## b
  #define SPROX_DESFIRE_GET_CTX()      SPROX_DESFIRE_CTX_ST *ctx = desfire_get_ctx(rInst); if (ctx == NULL) return MI_INVALID_READER_CONTEXT;
  #define SPROX_DESFIRE_GET_CTX_V()    SPROX_DESFIRE_CTX_ST *ctx = desfire_get_ctx(rInst); if (ctx == NULL) return;
  #define SPROX_API_CALL(a)            SPROXx_ ## a
  #define SPROX_PARAM        SPROX_INSTANCE rInst, 
  #define SPROX_PARAM_V      SPROX_INSTANCE rInst
  #define SPROX_PARAM_P      rInst,
  #define SPROX_PARAM_PV     rInst
  
  #include "hardware/springprox/springprox_ex.h"
  #include "sprox_desfire_ex.h"
   
#endif

#include "desfire.h"

/*
 * Function from SpringProx.dll not explictly available...
 */
#ifndef SPROX_API_REENTRANT
  SPRINGPROX_LIB SWORD SPRINGPROX_API SPROX_TclA_ExchangeDF(BYTE cid, const BYTE send_buffer[], WORD send_len, BYTE recv_buffer[], WORD *recv_len);
#else
  SPRINGPROX_LIB SWORD SPRINGPROX_API SPROXx_TclA_ExchangeDF(SPROX_INSTANCE rInst, BYTE cid, const BYTE send_buffer[], WORD send_len, BYTE recv_buffer[], WORD *recv_len);
#endif

/*
 * Functions from the desfire_crypto module
 */
#ifndef SPROX_API_REENTRANT
SPROX_DESFIRE_LIB void SPROX_DESFIRE_API SPROX_Desfire_CipherMAC(BYTE data[], WORD blocks, const BYTE key[16], BYTE result[4]);
SPROX_DESFIRE_LIB void SPROX_DESFIRE_API SPROX_Desfire_CipherMACb(BYTE data[], DWORD length, const BYTE key[16], BYTE result[4]);
SPROX_DESFIRE_LIB void SPROX_DESFIRE_API SPROX_Desfire_CipherRecv(BYTE data[], WORD blocks, const BYTE key[16]);
SPROX_DESFIRE_LIB void SPROX_DESFIRE_API SPROX_Desfire_CipherSend(BYTE data[], WORD blocks, const BYTE key[16]);
#else
SPROX_DESFIRE_LIB void SPROX_DESFIRE_API SPROXx_Desfire_CipherMAC(SPROX_INSTANCE rInst, BYTE data[], WORD blocks, const BYTE key[16], BYTE result[4]);
SPROX_DESFIRE_LIB void SPROX_DESFIRE_API SPROXx_Desfire_CipherMACb(SPROX_INSTANCE rInst, BYTE data[], DWORD length, const BYTE key[16], BYTE result[4]);
SPROX_DESFIRE_LIB void SPROX_DESFIRE_API SPROXx_Desfire_CipherRecv(SPROX_INSTANCE rInst, BYTE data[], WORD blocks, const BYTE key[16]);
SPROX_DESFIRE_LIB void SPROX_DESFIRE_API SPROXx_Desfire_CipherSend(SPROX_INSTANCE rInst, BYTE data[], WORD blocks, const BYTE key[16]);
#endif

/*
 * Internal module functions
 */
#ifndef SPROX_API_REENTRANT
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROX_Desfire_Command(BOOL fast, WORD accept_len, BYTE accept_status);
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROX_Desfire_ReadDataEx(BYTE read_command, BYTE file_id, BYTE comm_mode, DWORD from_offset, DWORD item_count, DWORD item_size, BYTE * data, DWORD * done_size);
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROX_Desfire_WriteDataEx(BYTE write_command, BYTE file_id, BYTE comm_mode, DWORD from_offset, DWORD size, const BYTE data[]);
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROX_Desfire_ModifyValue(BYTE modify_command, BYTE file_id, BYTE comm_mode, SDWORD amount);
#else
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROXx_Desfire_Command(SPROX_INSTANCE rInst, BOOL fast, WORD accept_len, BYTE accept_status);
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROXx_Desfire_ReadDataEx(SPROX_INSTANCE rInst, BYTE read_command, BYTE file_id, BYTE comm_mode, DWORD from_offset, DWORD item_count, DWORD item_size, BYTE * data, DWORD * done_size);
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROXx_Desfire_WriteDataEx(SPROX_INSTANCE rInst, BYTE write_command, BYTE file_id, BYTE comm_mode, DWORD from_offset, DWORD size, const BYTE data[]);
SPROX_DESFIRE_LIB SWORD SPROX_DESFIRE_API SPROXx_Desfire_ModifyValue(SPROX_INSTANCE rInst, BYTE modify_command, BYTE file_id, BYTE comm_mode, SDWORD amount);
#endif

/* Flags for DesFireCard_Command */
#define INF 0
#define ACCEPT_OPERATION_OK      0x01
#define ACCEPT_ADDITIONAL_FRAME  0x02


#define	INVALIDATE_AUTHENTICATION	          0xFF


#undef D
#define D(x)

void dump_buffer(const BYTE * buffer, WORD len);


#define DESFIRE_BUFFER_SIZE 4096



typedef struct
{
  BYTE cid;
  BYTE auth_key;
  BYTE session_key[16];
  WORD buflen;
  BYTE buffer[DESFIRE_BUFFER_SIZE];
  BYTE cipher_buffer[DESFIRE_BUFFER_SIZE+8];
  SPROX_DES_3DES_CTX_ST cipher_context;
} SPROX_DESFIRE_CTX_ST;

#ifndef SPROX_API_REENTRANT
  extern SPROX_DESFIRE_CTX_ST desfire_ctx;
#else
  SPROX_DESFIRE_CTX_ST *desfire_get_ctx(SPROX_INSTANCE rInst);
#endif

#endif
