#ifndef uSettingsH
#define uSettingsH

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Registry.hpp>

class TSettings
{
public:

  /* General screen */
  AnsiString Device;
  int ScanMode;
  int StartMode;

  /* Output screen */
  AnsiString Prefix;
  AnsiString Postfix;
  int ScanDelay;
  int ScanFilter;
  bool ScanBeep;
  bool RemoveLeading0;

  /* Mifare screen */
  int MifareBlock;
  int MifareOffset;
  int MifareSize;
  AnsiString MifareKey;
  int MifareFormat;
  bool MifareRevert;

  /* 14443-A screen */
  int Iso14443aSize;
  int Iso14443aFormat;
  bool Iso14443aRevert;
  bool Iso14443aATQ;
  bool Iso14443aSAK;
  bool Iso14443aA;

  /* 14443-B screen */
  int Iso14443bSize;
  int Iso14443bFormat;
  bool Iso14443bRevert;
  bool Iso14443bB;

  /* Utilities */
  bool SaveSettings();
  void LoadSettings();
  void BroadcastSettingsUpdated();

  bool GetMifareKey(unsigned char dst[6]);
  AnsiString Format14443B(unsigned char atq[11]);
  AnsiString Format14443A(unsigned char atq[2], unsigned char uid[12],
                          unsigned char uidlen, unsigned char sak[1]);
  AnsiString FormatMifare(unsigned char data[16]);

    TSettings();
};

extern TSettings *Settings;

#endif
